#include <stdio.h>
#define MAX_ROUTERS 1002

struct Connection_Data
{
	int Capacity;
	double Reliability;
};
struct Route_Data
{
	int MaxCapacity;
	double TotalReliability;
	double Effectiveness;
	int Processed;
	int Father;
};

FILE* fin = fopen ("network.inp", "rt");
FILE* fout = fopen ("network.out", "wt");

Connection_Data Graph[MAX_ROUTERS][MAX_ROUTERS];
Route_Data RouteTo[MAX_ROUTERS];

int main (void)
{
	int routers, lines;
	int i, j, w, k;
	int Source, Destination;

	for (i = 0; i < MAX_ROUTERS; i++)		// inicializacii
		for (j = 0; j < MAX_ROUTERS; j++)
		{
			Graph[i][j].Capacity = 0;
			Graph[i][j].Reliability = 0.0;
		}

	fscanf (fin, "%d%d", &routers, &lines);	// vhod
	for (i = 0; i < lines; i++)
	{
		fscanf(fin, "%d%d", &Source, &Destination);
		fscanf(fin, "%d%lf", &Graph[Source][Destination].Capacity, &Graph[Source][Destination].Reliability);
	}
	fscanf (fin, "%d%d", &Source, &Destination);

// Start Dejkstra
	double Eswk, Pswk, MaxEffectiveness;
	int Qswk;

	for (i = 1; i <= routers; i++)
	{
		RouteTo[i].Processed = 0;
		RouteTo[i].MaxCapacity = Graph[Source][i].Capacity;
		RouteTo[i].TotalReliability = Graph[Source][i].Reliability;
		RouteTo[i].Effectiveness = Graph[Source][i].Capacity * Graph[Source][i].Reliability;
		RouteTo[i].Father = Source;
	}
	RouteTo[Source].Processed = 1;
	RouteTo[Source].Father = -1;

	for (i = 1; i <= routers - 1; i++)
	{
		MaxEffectiveness = 0.0;
		for (j = 1; j <= routers; j++)
			if (RouteTo[j].Processed == 0 && RouteTo[j].Effectiveness > MaxEffectiveness && RouteTo[j].MaxCapacity != 0)
			{
				MaxEffectiveness = RouteTo[j].Effectiveness;
				w = j;
			}
		if (MaxEffectiveness == 0.0) break;
/*1*/		if (w == Destination) break;

		RouteTo[w].Processed = 1;

		for (k = 1; k <= routers; k++)
			if (Graph[w][k].Capacity != 0)
			{
				Pswk = RouteTo[w].TotalReliability * Graph[w][k].Reliability;
				Qswk = (RouteTo[w].MaxCapacity < Graph[w][k].Capacity) ? (RouteTo[w].MaxCapacity) : (Graph[w][k].Capacity);
				Eswk = Pswk * Qswk;
				if (RouteTo[k].Effectiveness < Eswk)
				{
					RouteTo[k].MaxCapacity = Qswk;
					RouteTo[k].TotalReliability = Pswk;
					RouteTo[k].Effectiveness = Eswk;
					RouteTo[k].Father = w;
				}
			}
	}
// End Dejkstra

	if (RouteTo[Destination].Effectiveness > 0.0)
	{
		int Stack[MAX_ROUTERS], StIndex = 0;

		fprintf (fout, "%.6lf ", RouteTo[Destination].Effectiveness);
		i = Destination;
		while (i != -1)
		{
			Stack[StIndex++] = i;
			i = RouteTo[i].Father;
		}
	
		fprintf (fout, "%d\n", StIndex);
		for (i = StIndex - 1; i >= 0; i--)
		{
			fprintf (fout, "%d", Stack[i]);
			if (i > 0) fprintf (fout, " ");
		}
		fprintf (fout, "\n");
	}
	else
		fprintf (fout, "0 0\n\n");

	fclose (fin);
	fclose (fout);
	return 0;
}
