
Const
  MaxN = 1000;
  MaxWord = 65535;
  Eps = 0.000001;


Type
  TPath = record
    Q: Word;
    P: Double;
  end;
  PMas = ^TMas;
  TMas = Array[1..MaxN] of TPath;

Var
  N, M: LongInt;
  Mas : Array[1..MaxN] of PMas;
  FF  : Array[1..MaxN] of PMas;
  Used: Array[1..MaxN] of Boolean;

Procedure Solve(A, B: Integer;var Path: TPath);
var
  i    : Integer;
  Temp : TPath;
  E, E1: Double;
begin
  if (FF[A]^[B].Q = 0) and not Used[A] then
  begin
    FillChar(Path, SizeOf(Path), 0);
    E := 0;
    Used[A] := True;
    for i := 1 to N do
      if Mas[A]^[i].Q <> 0 then
      begin
        Solve(i, B, Temp);
        with Temp do
        begin
          P := P*Mas[A]^[i].P;
          if Q > Mas[A]^[i].Q then
            Q := Mas[A]^[i].Q;
          E1 := P*Q;
        end;
        if E1 > E then
        begin
          E := E1;
          Path := Temp;
        end;
      end;
    FF[A]^[B] := Path;
    Used[A] := False;
  end else Path := FF[A]^[B];
end;

Var
  Way : Array[1..MaxN] of Integer;
  Len : Integer;

Function Min(A, B: Word): Word;
begin
  if A < B then Min := A else Min := B;
end;

Function EQ(A, B: Double): Boolean;
begin
  EQ := Abs(A-B) < Eps;
end;

Function FindWay(A, B: Integer): Boolean;
var
  i: Integer;
begin
  Len := Len + 1;
  Way[Len] := A;
  FindWay := True;
  if A = B then Exit;
  for i := 1 to N do
    with Mas[Way[Len]]^[i] do
      if Q <> 0 then
      begin
        if EQ(Mas[Way[Len]]^[i].P*FF[i]^[B].P, FF[A]^[B].P) and
           (Min(Mas[Way[Len]]^[i].Q, FF[i]^[B].Q) = FF[A]^[B].Q) then
        begin
          if FindWay(i, B) then Exit;
        end;
      end;
  Len := Len-1;
  FindWay := False;
end;

Var
  A, B: Integer;
  Path: TPath;
  i   : LongInt;
  E   : Double;

Begin
  Assign(Input, 'NETWORK.IN1');
  ReSet(Input);
  Assign(Output, 'NETWORK.OUT');
  ReWrite(Output);

  ReadLn(N, M);
  for i := 1 to N do
  begin
    New(Mas[i]);
    New(FF[i]);
    FillChar(Mas[i]^, SizeOf(TMas), 0);
    FillChar(FF[i]^, SizeOf(TMas), 0);
    with FF[i]^[i] do
    begin
      Q := MaxWord;
      P := 1;
    end;
  end;
  for i := 1 to M do
  begin
    Read(A, B);
    with Mas[A]^[B] do
      ReadLn(Q, P);
  end;
  ReadLn(A, B);
  Solve(A, B, Path);
  with Path do
    if P*Q <> 0 then
    begin
      Write(P*Q:1:6);
      Len := 0;
      FindWay(A, B);
      WriteLn(' ', Len);
      for i := 1 to Len do
      begin
        if i > 1 then Write(' ');
        Write(Way[i]);
      end;
      WriteLn;
    end else WriteLn('0 0');

  for i := 1 to N do
  begin
    DisPose(FF[i]);
    DisPose(Mas[i]);
  end;

  Close(Input);
  Close(Output);
End.