#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <conio.h>

int N, M;
int base1, base2;
int id_fl[1001]={0};

ifstream rd;
ofstream wrt;

class Router
{ public:
    Router *left,
	   *right;
    int key_l, key_r;
    Router *drct, *path;
    int id;
    int host;
    unsigned int kbps;
    float kpd;
    float Pp;
    unsigned int Qp;
    float weight;
   Router(){left=right=drct=0; key_l=key_r=0;}
};

Router *rt[1001]={0};
Router **crr[1001];
Router *top=0;

void push (Router *put)
{  Router *buf=top;

if (!top){top=put; return;}
if (put->weight>top->weight)
   { put->left=top; put->key_l=top->key_l+top->key_r+1;
     top=put; return;}


while(1)
{
  if (buf->key_l<buf->key_r)
    {buf->key_l++;
       if (!buf->left){buf->left=put; return;}
       if (put->weight<buf->left->weight){ buf=buf->left;}
       else {put->left=buf->left; put->key_l=buf->key_l-1;
	     buf->left=put; return;}
   }
else { buf->key_r++;
       if (!buf->right){buf->right=put; return;}
       if (put->weight<buf->right->weight){ buf=buf->right;}
       else {put->right=buf->right; put->key_r=buf->key_r-1;
	     buf->right=put; return;}
      }
}
}


Router* pop()
{ Router *tree, *buf, *change, *rtn=top;
	if(!top) return top;
	if(!top->left){top=top->right; return rtn;}
	if(!top->right){top=top->left; return rtn;}

     if (top->left->weight>top->right->weight)
       { tree=top->right; top=top->left;}
     else { tree=top->left; top=top->right;}
  buf=top;

while(1)
   { if (buf->key_l<buf->key_r)
       {
	  if (!buf->left){ buf->key_l+=tree->key_l+tree->key_r+1;
			   buf->left=tree; return rtn;}

	  if (tree->weight<=buf->left->weight)
	    { buf->key_l+=tree->key_l+tree->key_r+1; buf=buf->left; }
	  else { change=tree; tree=buf->left; buf->left=change;
		 buf->key_l=buf->left->key_l+buf->left->key_r+1;}
       }

     else {
	    if(!buf->right){ buf->key_r+=tree->key_l+tree->key_r+1;
			     buf->right=tree; return rtn;}

	    if (tree->weight<=buf->right->weight)
	      { buf->key_r+=tree->key_l+tree->key_r+1; buf=buf->right; }
	    else { change=tree; tree=buf->right; buf->right=change;
		 buf->key_r=buf->right->key_l+buf->right->key_r+1;}
	  }
   }
}

void get();
void launch();
void add(Router*, Router*);
void send(Router*);
void No();

void main()
{
get();
launch();
}

void get()
{     int router, kbps, host; float kpd;  int i;
  char buf[50];

  rd.open("NETWORK.INP", ios::in);
  if(!rd){cout<<"\nCant open file NETWORK.INP"; getch(); exit(0);}

  rd>>buf; N=atoi(buf); rd>>buf; M=atoi(buf);

  for(i=1;i<=N;i++)
     { crr[i]=&rt[i];}
  for(i=0;i<M;i++)
     {  rd>>buf; router=atoi(buf); rd>>buf; host=atoi(buf);
	rd>>buf; kbps=atoi(buf); rd>>buf; kpd=atof(buf);
	if ( !(*crr[router]=new Router) )
	  {cout<<"\nNot enough memory!";exit(0);}
	 (*crr[router])->id=router;
	(*crr[router])->host=host; (*crr[router])->kbps=kbps;
	(*crr[router])->kpd=kpd; crr[router]=&(*crr[router])->drct;
     }
   rd>>buf; base1=atoi(buf); rd>>buf; base2=atoi(buf);
  rd.close();
}

void launch()
{
Router *buf=rt[base1]; id_fl[base1]=1;
   while(buf){ buf->path=0; buf->Qp=buf->kbps; buf->Pp=buf->kpd;
	       buf->weight=buf->Pp*buf->Qp;push(buf); buf=buf->drct;
	     }
while(1)
{
   buf=pop(); if (!buf)No(); if(buf->host==base2) send(buf);
   if (!id_fl[buf->host])
     { id_fl[buf->host]=1;
       add(rt[buf->host], buf); }
}
}

void add(Router* x, Router *y)
{
while(x){ if(id_fl[x->host]){x=x->drct; continue;}
	   x->path=y;
	   x->Pp=x->path->Pp*x->kpd;
	   if (x->kbps<x->path->Qp){ x->Qp=x->kbps; }
	   else { x->Qp=x->path->Qp;}
		x->weight=x->Pp*x->Qp;
		push(x); x=x->drct;
	 }
}

void send(Router *best)
{  int res[1000]={0}; int count=0;

  wrt.open("NETWORK.OUT", ios::out);
  if(!wrt){cout<<"\nCant open file!"; exit(0);}
   wrt.setf(ios::showpoint);
  wrt<<best->weight<<' ';

   while(best){res[count]=best->id; count++; best=best->path;}

  wrt<<(count+1)<<'\n';
  while(count){count--;wrt<<res[count]<<' ';}
  wrt<<base2<<'\n';
  wrt.close();    exit(0);
}

void No()
{   wrt.open("NETWORK.OUT", ios::out);
  if(!wrt){cout<<"\nCant open file!"; exit(0);}
  wrt<<"0 0\n";
  wrt.close();  exit(0);
}

