#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vector>
#include <memory.h>

#define MAX_N 1000
#define MAX_Q 65536

typedef struct { int x; int q; double p; } line;
typedef struct { std::vector<line *> lines; } line_list;

line * total_line_list;

line_list neigh[MAX_N];
int n;
int path[MAX_N], pt;

double E;

int start, end;
int parent[MAX_N], visited[MAX_N];

double dist[MAX_N];
int minq[MAX_N]; double ppp[MAX_N];

int used_Q[MAX_Q], uQ, maxq;

int c_minq[MAX_N]; double c_ppp[MAX_N];
int used[MAX_N];

///////////////////////////////

int pyr[MAX_N], p_size;
int pyr_idx[MAX_N];

int currentQ;

void c_repair_pyr_up( int i )
{
   int p, t;
   double dk = c_ppp[ pyr[i] ];

   for (; i;)
   {
      p = (i - 1) / 2;
      if ( dk > c_ppp[ pyr[p] ] )
      {
         pyr_idx[ pyr[i] ] = p;
         pyr_idx[ pyr[p] ] = i;

         t = pyr[i];
         pyr[i] = pyr[p];
         pyr[p] = t;

         i = p;
      }
      else
      {
         break;
      }
   }
}

void c_insert_pyr( int k )
{
   int i;
   double dk = c_ppp[k];

   pyr[ i = p_size++ ] = k;
   pyr_idx[k] = i;

   c_repair_pyr_up(i);
}

void c_repair_pyr( int i )
{
   int l, r, t, x;
   double dk;

   dk = c_ppp[ pyr[i] ];

   for (;;)
   {
      l = 2*i + 1;
      r = l + 1;

      if ( l >= p_size ) break;
      if ( r >= p_size )
      {
         if ( dk >= c_ppp[ pyr[l] ] ) break;

         pyr_idx[ pyr[i] ] = l;
         pyr_idx[ pyr[l] ] = i;

         t = pyr[l];
         pyr[l] = pyr[i];
         pyr[i] = t;

         i = l;
      }
      else
      {
         if ( ( dk >= c_ppp[ pyr[l] ] ) && ( dk >= c_ppp[ pyr[r] ] ) ) break;

         x = ( c_ppp[ pyr[l] ] > c_ppp[ pyr[r] ] ) ? l : r;

         pyr_idx[ pyr[i] ] = x;
         pyr_idx[ pyr[x] ] = i;

         t = pyr[x];
         pyr[x] = pyr[i];
         pyr[i] = t;

         i = x;
      }
   }
}

void c_remove_pyr_top( void )
{
   if ( p_size == 1 ) { p_size = 0; return; }

   pyr_idx[ pyr[0] ] = -1;
   pyr[0] = pyr[ --p_size ];
   c_repair_pyr(0);
}

int part_dijk( void )
{
   int i, t, e;
   int mq; double mp; double md;

   for ( i = 0; i < n; i++ ) { parent[i] = -1; pyr_idx[i] = -1; }
   
   visited[start] = 1;

   for ( i = 0; i < neigh[start].lines.size(); i++ )
   {
      e = neigh[start].lines[i]->x;

      if ( neigh[start].lines[i]->q >= currentQ )
      {
         used[e] = (neigh[start].lines[i]->q == currentQ);
         c_minq[e] = neigh[start].lines[i]->q;
         c_ppp[e] = neigh[start].lines[i]->p;
         parent[e] = start;

         c_insert_pyr(e);
      }
   }

   for (; p_size;)
   {
      t = pyr[0];
      c_remove_pyr_top();
      visited[t] = 1;

      for ( i = 0; i < neigh[t].lines.size(); i++ )
      {
         e = neigh[t].lines[i]->x;

         if ( (!visited[e]) )
         {
            mp = c_ppp[t]*neigh[t].lines[i]->p;
            if ( neigh[t].lines[i]->q < (mq = c_minq[t]) ) mq = neigh[t].lines[i]->q;
            md = mq*mp;

            if ( mq >= currentQ )
            if ( (parent[e] == -1) || (mp > c_ppp[e]) )
            {
               used[e] = used[t] || (mq == currentQ);
               parent[e] = t;               
               c_ppp[e] = mp; c_minq[e] = mq;

               if ( pyr_idx[e] == -1 )
                  c_insert_pyr(e);
               else
                  c_repair_pyr_up( pyr_idx[e] );
            }
         }
      }
   }

   if ( (parent[end] != -1) && used[end] )
   {
      double c_dist = c_ppp[end]*currentQ;
      if ( c_dist > E )
      {
         E = c_dist;
         i = end;
         pt = 0;

         do
         {
            path[pt++] = i;
            i = parent[i];
         } while ( i != -1 );

         i = pt;
      }
   }

   return (parent[end] != -1);
}

void process_dijkstras( void )
{
   int i;

   uQ = 0;
   for ( i = 0; i <= maxq; i++ )
      if ( used_Q[i] ) used_Q[ uQ++ ] = i;

   for ( i = 0; i < uQ; i++ )
   {
      currentQ = used_Q[i];

      p_size = 0;
      memset( visited, 0, sizeof(int)*n );
      memset( used, 0, sizeof(int)*n );
      if ( !part_dijk() ) break;
   }
}

////////////////////////

int main( void )
{
   int i, m;
   int b, e, q; double p;
   line * l;

   FILE * f = fopen( "network.inp", "r" );
   fscanf( f, "%d %d", &n, &m );

   if (m) total_line_list = (line *) malloc( sizeof(line)*m );

   maxq = 0;
   
   for ( i = 0; i < m; i++ )
   {
      fscanf( f, "%d %d %d %lf", &b, &e, &q, &p );

      l = total_line_list + i;
      --b; --e;
      
      l->x = e; l->q = q; l->p = p;
      neigh[b].lines.push_back(l);

      used_Q[q] = 1;
      if ( maxq < q ) maxq = q;
   }

   fscanf( f, "%d %d", &start, &end );
   --start; --end;
   
   fclose(f);

   process_dijkstras();

   if (m) free( total_line_list );

   f = fopen( "network.out", "w" );

   if ( !pt )
   {
      fprintf( f, "0 0\n" );
   }
   else
   {
      fprintf( f, "%.6lf %d\n", E, pt );
      fprintf( f, "%d", path[ --pt ] + 1 );

      for ( ; pt > 0; pt-- ) fprintf( f, " %d", path[pt - 1] + 1 );
   }

   fclose(f);

   return 0;
}
