{ Reshenie na zadacha 3 ot konkursa na PC Magazine i Musala Soft 
  avtor: Peter Kormushev
 Kompiliran na Free Pascal
}
type
    Trebro = record
            q:word;   { propusklivost }
            p:double; { nadevnost }
    end;
    Tnode = record
             Visited:boolean;
             Parent,
             HeapIndx:word;
             minQ  : word;
             prodP : double;
            end;
const
     MAX_N = 1000;

var
   graph:array[1..MAX_N,1..MAX_N] of Trebro;
   router:array[1..MAX_N] of Tnode;

   n: word; { broj varhove }
   m: longint; { broj rebra }
   c,d: word; { src & target }

function min(var a,b:word):word;
begin
     if a<b then min:=a
     else min:=b;
end;

procedure LoadGraph;
var a,b:word;
    f:text;
    i:longint; {!!!}
    w1:word;
    d1:double;
begin

     assign(f,'network.inp');
     reset(f);
     readln(f,n,m);

     for a:=1 to n do
         for b:=1 to n do
             graph[a,b].q := 0;   { ie no edge }

     for i:=1 to m do
     begin
          readln(f,a,b,w1,d1);
          graph[a,b].q:=w1;
          graph[a,b].p:=d1;
     end;
     read(f,c,d);

     close(f);
end;

type
    HKeyType = double;          { - }
    weighttype = double;
    nodeptr = word; { index na node }
    HInfoType = record
                    key:hkeytype;
                    node:nodeptr;
                end;
    itemstype=array[1..MAX_N] of hinfotype;
    HeapType = record
                  items:itemstype;
                  count:integer   {   .   }
               end;

function FindMaxFlowpath(src,dest:nodeptr):boolean;
var
   nodePQ:heaptype;
   item:Hinfotype;
   edge:nodeptr;
   parent,child:^Tnode;
   newminq : word;
   newprodp: double;
   ncount:integer;

procedure HeapInit(var heap:heaptype);
begin
     heap.count:=0;
end;
function HeapEmpty(const heap:heaptype):boolean;
begin
     heapempty:=heap.count=0;
end;
procedure Adjustup(var heap:heaptype; hole:integer);  {  HeapInsert }
var
   parent:integer;
   item:hinfotype;
begin
     with heap do
     begin
          item:=items[hole];
          parent:=hole div 2;
          while parent>=1 do
          begin
               if item.key > items[parent].key then          { | > }
               begin
                    items[hole]:=items[parent];
                    router[items[parent].node].heapindx:=hole;
                    hole:=parent;
               end;
               parent:=parent div 2
          end;
          items[hole]:=item
     end;
     child^.heapindx:=hole
end;
procedure HeapInsert(var heap:heaptype; var item:hinfotype);
begin
     with heap do
     begin
          inc(count);
          items[count]:=item;
          adjustup(heap,count)
     end
end;

procedure Adjustdown(var heap:heaptype);           {  HeapDelete  }
var
   child, parent:integer;
   item:hinfotype;
begin
     with heap do
     begin
          parent:=1;
          item:=items[1];
          child:=2;
          while child <= count do
          begin
               if child+1<=count then
                  if items[child+1].key > items[child].key then   { > }
                     inc(child);
               if item.key < items[child].key then                 { < }
               begin
                    items[parent]:=items[child];
                    router[items[child].Node].heapindx:=parent;
                    parent:=child;
                    child:=parent*2
               end
               else
                   child:=maxint  {      !!}
          end;
          items[parent]:=item;
          router[items[parent].node].heapindx:=parent
     end
end;
procedure HeapDelete(var heap:heaptype; var item:hinfotype);
begin
     with heap do
     begin
          item:=items[1];
          items[1]:=items[count];
          dec(count);
          adjustdown(heap)
     end
end;
var i:word;
BEGIN    { FindMaxFlowpath }
     for i:=1 to n do
     begin
          router[i].minq:=0;
          router[i].prodP:=0;
          router[i].parent:=0;
          router[i].heapindx:=0;
     end;

     heapinit(nodePQ);
     parent:=@router[src];
     parent^.minq:=MAXINT;
     parent^.prodp:=1;
     parent^.parent:=0;

     ncount:=1;
     repeat

         for i:=1 to n do
         if graph[src,i].q > 0  { ima rebro }
         then begin
                child:=@router[i];
                newminq := min (parent^.minq, graph[src,i].q);
                newprodp := parent^.prodp * graph[src,i].p;

                if (newminq * newprodp) >
                   (child^.minq * child^.prodp) then
                begin
                     child^.parent:=src;
                     child^.minq:=newminq;
                     child^.prodp:=newprodp;
                     if child^.heapindx <> 0 then
                     begin
                          nodepq.items[child^.heapindx].key := (newminq * newprodp);
                          adjustup(nodepq,child^.heapindx);
                     end
                     else begin
                          item.node:=i;
                          item.key:=(newminq * newprodp);
                          heapinsert(nodepq,item)
                     end;
                end;

         end; { for i }


         if HeapEmpty(nodepq) then break
         else begin
            heapdelete(nodepq,item);
            src := item.node;
            if src = dest     then break;
            parent:= @router[src];
            inc(ncount);
         end;

     until false;

   FindMaxFlowpath:=src = dest;  { true if dest was reached }
END;   { FindMaxFlowpath }

var path:array[1..MAX_N] of word;
    pathcount:longint;

Procedure FollowPath(ptr:nodeptr);    {      }
begin
     if ptr<>0 then
     begin
          followpath(router[ptr].parent);
          inc(pathcount);
          path[pathcount]:=ptr;
     end
end;

VAR
   i:longint;
   f:text;
BEGIN
     LoadGraph;
     assign(f,'network.out');
     rewrite(f);
     if FindMaxFlowpath(c,d) then
     begin
{          writeln('Solution found !');}
          pathcount:=0;
          FollowPath(d);
          writeln(f,(router[d].minq * router[d].prodp) :0:6, ' ', pathcount);
          for i:=1 to pathcount do write(f,path[i],' ');
          writeln(f);
     end
     else begin
          writeln(f,'0 0');   { no solution found }
     end;
     close(f);

END.