/*

VIII PC Magazine Bulgaria & Musala Soft programming contest
Problem 3: NETWORK

Author: Peter Ivanov Petrov, 21, Sofia
        software developer / university student
        e-mail: piettropro@bigfoot.com
        www: http://pesho.cjb.net, http://www.pesho.com
        phone: (359-2)9340014


VIII     PC Magazine Bulgaria  Musala Soft
 3:  

:   , 21 ., . 
        / 
       e-mail: piettropro@bigfoot.com
       www: http://pesho.cjb.net, http://www.pesho.com
       . (359-2)9340014
*/

#include <stdio.h>
#include <stdlib.h>


enum { MAX_N=1024, MAX_Q=66000 };


struct edge {
	int k,Q; double P;

	edge(int _k=0,int _Q=65536,double _P=1.0) : k(_k),Q(_Q),P(_P) { }
	edge(const edge& e) : k(e.k),Q(e.Q),P(e.P) { }
};


int N,M,C,D,grc[MAX_N];
edge gr[MAX_N][MAX_N];
double dp[MAX_N]; int dq[MAX_N],path[MAX_N];
double bestE; int bestCount,bestPath[MAX_N];


void dijkstra(int minq) {
	int i,count=grc[D-1]; const edge *p=gr[D-1]; bool s[MAX_N];
	for(i=0;i<N;++i) s[i]=false; s[D-1]=true;
	for(i=0;i<N;++i) { dp[i]=-1; dq[i]=-1; path[i]=-1; }
	for(i=0;i<count;++i) if (p[i].Q>=minq) {
		const edge& r=p[i]; int k=r.k;
		dp[k]=r.P; dq[k]=r.Q; path[k]=D-1;
	}
	for(i=0;i<N-2;++i) {
		int j,bestj=-1,bestq=-1; double bestp=-1;
		for(j=0;j<N;++j) if ((!s[j]) && (dq[j]!=-1)) 
			if ((dp[j]>bestp) || ((dp[j]==bestp) && (dq[j]>bestq))) {
				bestp=dp[j]; bestq=dq[j]; bestj=j;
			}
		if ((bestj==-1) || (bestj==C-1)) return; s[bestj]=true;
		for(j=0,count=grc[bestj],p=gr[bestj];j<count;++j) {
			const edge &r=p[j]; if (r.Q<minq) continue;
			int k=r.k; if (s[k]) continue;
			int newq=((dq[bestj]<r.Q)?(dq[bestj]):(r.Q));
			double newp=dp[bestj]*r.P;
			if ((dq[k]==-1) || (newp>dp[k]) || 
				((newp==dp[k]) && (newq>dq[k]))) { 
				dq[k]=newq; dp[k]=newp; path[k]=bestj;
			}
		}
	}
}

void main() {
	FILE *fp=fopen("Network.inp","rt"); if (!fp) abort();
	fscanf(fp,"%d%d",&N,&M);
	int i; for(i=0;i<N;++i) grc[i]=0;
	bool q_all[MAX_Q+1]; int q_max=0;
	for(i=0;i<=MAX_Q;++i) q_all[i]=false;
	for(i=0;i<M;++i) {
		int a,b,Q; double P;
		fscanf(fp,"%d%d%d%lf",&a,&b,&Q,&P);
		if (Q>q_max) q_max=Q; q_all[Q]=true;
		gr[b-1][grc[b-1]++]=edge(a-1,Q,P);
	}
	fscanf(fp,"%d%d",&C,&D);
	fclose(fp);
	//
	bestCount=-1; bestE=-1;
	for(i=0;i<=q_max;) {
		while((i<=q_max) && (!q_all[i])) ++i; if (i>q_max) break;
		dijkstra(i); int nowQ=dq[C-1]; if (nowQ==-1) break;
		double nowE=nowQ*dp[C-1];
		if (nowE>bestE) {
			bestE=nowE; bestCount=0; int v;
			for(v=C-1;v!=-1;v=path[v]) bestPath[bestCount++]=v;
		}
		i=nowQ+1;
	}
	//
	fp=fopen("Network.out","wt"); if (!fp) abort();
	if (bestCount==-1) {
		fprintf(fp,"0 0\n");
	} else {
		fprintf(fp,"%.6lf %d\n",bestE,bestCount);
		for(i=0;i<bestCount;++i) {
			if (i) fprintf(fp," ");
			fprintf(fp,"%d",bestPath[i]+1);
		}
		fprintf(fp,"\n");
	}
	fclose(fp);
}
